/**
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat, Inc. and/or its affiliates, and individual
 * contributors by the @authors tag. See the copyright.txt in the
 * distribution for a full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.weld.environment.servlet.test.provider;

import static org.jboss.weld.environment.servlet.test.util.Deployments.baseDeployment;
import static org.junit.Assert.assertTrue;

import javax.enterprise.inject.spi.CDI;

import org.jboss.shrinkwrap.api.spec.WebArchive;
import org.junit.Test;

public class CustomCDIProviderTestBase {

    public static WebArchive deployment() {
        return baseDeployment().addPackage(CustomCDIProviderTestBase.class.getPackage());
    }

    @Test
    public void testCustomCDIProvider() {
        MyCDIProvider.reset();
        CDI<Object> discovered = CDI.current();
        CDI.setCDIProvider(new MyCDIProvider(discovered));
        CDI.current();
        assertTrue(MyCDIProvider.isCalled);
    }
}
